import * as Kecubung from "kecubung";
import * as Core from "kamboja-core";
export declare function when(kind: Kecubung.MetadataType): (target: any, method: string, descriptor: PropertyDescriptor) => void;
export declare function getWhen(target: any, methodName: string): Kecubung.MetadataType;
export declare abstract class TransformerBase {
    protected transformers: TransformerBase[];
    abstract transform(meta: Kecubung.MetaData, parent: string, prevResult: Core.RouteInfo[] | undefined): Core.TransformResult;
    protected transformChildren(children: Kecubung.MetaData[], parent: string): Core.RouteInfo[];
    protected next(result?: Core.RouteInfo[] | Core.RouteInfo): Core.TransformResult;
    protected exit(result?: Core.RouteInfo[] | Core.RouteInfo): Core.TransformResult;
}
