import * as Kecubung from "kecubung";
import * as Core from "kamboja-core";
import { TransformerBase } from "./transformer-base";
import { ApiConventionTransformer } from "./api-convention";
import { DefaultActionTransformer } from "./default-action";
import { HttpDecoratorTransformer } from "./http-decorator";
import { InternalDecoratorTransformer } from "./internal-decorator";
import { EventDecoratorTransformer } from "./event-decorator";
export declare function getTransformers(meta: Kecubung.ClassMetaData): (ApiConventionTransformer | DefaultActionTransformer | HttpDecoratorTransformer | InternalDecoratorTransformer | EventDecoratorTransformer)[];
export declare function checkForAnalysis(meta: Kecubung.ClassMetaData): Core.RouteInfo | undefined;
export declare class ControllerTransformer extends TransformerBase {
    transform(meta: Kecubung.ClassMetaData, parent: string, prevResult: Core.RouteInfo[]): Core.TransformResult;
}
